require "oj"
require "ruuaby/version"
require "ruuaby/configuration"

module Ruuaby
  @@countries = nil

  class << self
    def countries
      @@countries
    end

    def load_data
      @@countries ||= begin
        data = File.read(path_for_file)
        Oj.load(data)
      end
    end
    
    def each(&block)
      @@countries.each do |country_name, regions|
        regions.each do |region_name, areas|
          areas.each do |area_name, cities|
            cities.each do |city_name, city|
              yield(country_name, region_name, area_name, city_name) if block
            end
          end
        end
      end
    end

    private
      def path_for_file
        raise "Data path not found: #{data_path}" unless Dir.exists?(data_path)
        File.join(data_path, "data.json")
      end
  end
end
